<?php

#-----------------------------------------------------------------
# Include Custom CSS in Theme Header
#-----------------------------------------------------------------

if ( ! function_exists( 'theme_custom_styles' ) ) :
function theme_custom_styles() {

	// Get header and footer information
	$header = get_layout_header();
	
	#-----------------------------------------------------------------
	# Styles from Theme Options
	#-----------------------------------------------------------------

	// Accent Color - Primary
	//................................................................

	$accent_1 = get_options_data('options-page', 'accent-color-1');
	$accent_1_rgb = get_as_rgba($accent_1, .4);
	?>
	.accent-primary, #Top, .jp-play-bar, .jp-volume-bar-value, .wpb_button.wpb_accent-primary, button.vc_btn3.vc_btn3-color-accent-primary, a.vc_btn3.vc_btn3-color-accent-primary, .vc_progress_bar .vc_single_bar .vc_bar { background-color: <?php echo $accent_1 ?>; }
	a.styled-image:hover .inner-overlay, a.plain-image:hover .inner-overlay { background-color: <?php echo $accent_1_rgb ?>; }
	div.wpb_content_element div.ui-tabs .ui-tabs-nav li.ui-tabs-active, div.wpb_content_element div.ui-tabs .ui-tabs-nav li.ui-tabs-active:hover { border-top-color: <?php echo $accent_1 ?>; }
	.widget-area .widget li[class*="current"], div.wpb_tour .ui-tabs .ui-tabs-nav li.ui-tabs-active a, div.wpb_tour .ui-tabs .ui-tabs-nav li.ui-tabs-active a:hover { border-bottom-color: <?php echo $accent_1 ?>; }
	body #MainNav nav.ubermenu.ubermenu-main > li.ubermenu-current-menu-item > a .ubermenu-target-title, div.wpb_content_element .ui-state-default .ui-icon:before, div.wpb_content_element .ui-state-active .ui-icon:before, #content div.wpb_wrapper h4.wpb_toggle:hover, #content div.wpb_wrapper h4.wpb_toggle:before, .vc_cta3.vc_cta3-color-accent-primary {
		color: <?php echo $accent_1 ?>; }<?php 

	// Accent Color - Secondary
	//................................................................

	$accent_2 = get_options_data('options-page', 'accent-color-2');
	?>
	h1 em, h2 em, h3 em, h4 em, h5 em, h6 em, h2.wpb_call_text em,
	#MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul.ubermenu-submenu li.ubermenu-highlight > a, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-has-submenu-mega ul.ubermenu-submenu li.ubermenu-highlight > a { color: <?php echo $accent_2 ?>; }
	.accent-secondary, .impactBtn, .impactBtn:hover, .impactBtn:active, .wpb_call_to_action .wpb_button, .wpb_call_to_action .wpb_button:hover, .wpb_call_to_action .wpb_button:active { background-color: <?php echo $accent_2 ?>; }
	<?php 

	// Body background
	//................................................................

	$bodyBg       = get_options_data('options-page', 'background-color');
	$bodyPosition = get_options_data('options-page', 'background-position');
	$bodyImage    = get_options_data('options-page', 'background-image');
	if ( $bodyImage && $bodyPosition != 'full-screen' ) {
		$bodyBg .= ' url('. $bodyImage .') '. get_options_data('options-page', 'background-repeat') .' '. $bodyPosition . ' top'; 
	}
	?>
	body, body.boxed { background: <?php echo $bodyBg ?>; }
	<?php

	// Links
	//................................................................

	$linkColor = get_options_data('options-page', 'link-color');
	if (!empty($linkColor)) { ?>
		a, .widget-area .widget a { color: <?php echo $linkColor ?>; }
		<?php
	}
	// Hover (links)
	$hoverColor = get_options_data('options-page', 'link-hover-color');
	if (!empty($hoverColor)) { ?>
		a:hover, .entry-title a:hover, .wpb_carousel .post-title a:hover, .wpb_accordion .ui-accordion .ui-accordion-header a:hover, .widget-area .widget a:hover, #Bottom a, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-has-submenu-mega ul ul.ubermenu-submenu li.ubermenu-item a:hover, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item:hover > a, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > a:hover, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-active > a .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item:hover > span.um-anchoremulator, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > span.um-anchoremulator:hover, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-active > span.um-anchoremulator, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item:hover > a, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-active > a .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item:hover > span.um-anchoremulator, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-active > span.um-anchoremulator, div.wpb_content_element .ui-state-default .ui-icon:before, div.wpb_content_element .ui-state-active .ui-icon:before, #content div.wpb_wrapper h4.wpb_toggle:hover, #content div.wpb_wrapper h4.wpb_toggle:before, div.wpb_content_element .ui-tabs .ui-tabs-nav a:hover { color: <?php echo $hoverColor ?>; }
		<?php
	}

	// Header background
	//................................................................
	$headerSuffix = $header['alias'];
	$headerBg = get_options_data('options-page', 'header-background-color');

	if ( (get_options_data('layout_header_'.$headerSuffix, 'field-UN7zuQme4KUW')) != "" && (get_options_data('layout_header_'.$headerSuffix, 'field-UN7zuQme4KUW')) != "#" ) {
		$headerBg = get_options_data('layout_header_'.$headerSuffix, 'field-UN7zuQme4KUW');
	}
	// Default header backgorund image
	if ($headerBgImage = get_options_data('options-page', 'header-background-image')) {
		$headerBgRepeat = get_options_data('options-page', 'header-background-repeat');
		$headerBgPosition = get_options_data('options-page', 'header-background-position');
	}
	// Header specific background image
	if ( get_options_data('layout_header_'.$headerSuffix, 'field-Nw3gSryVhNQs') != "" ) {

		$headerBgImage = get_options_data('layout_header_'.$headerSuffix, 'field-Nw3gSryVhNQs');

		if ( get_options_data('layout_header_'.$headerSuffix, 'field-i5uQbAXt0P3q') != "" )
			$headerBgRepeat = get_options_data('layout_header_'.$headerSuffix, 'field-i5uQbAXt0P3q');
		if ( $headerBgRepeat == 'vertical-repeat' ) { $headerBgRepeat = 'repeat-y'; }
		if ( $headerBgRepeat == 'horizontal-repeat' ) { $headerBgRepeat = 'repeat-x'; }
		if ( get_options_data('layout_header_'.$headerSuffix, 'field-ovkmvULbvkGu') != "" )
			$headerBgPosition = get_options_data('layout_header_'.$headerSuffix, 'field-ovkmvULbvkGu');	
	}
	if ($headerBgImage) {
		$headerBg .= ' url('. $headerBgImage .') '. $headerBgRepeat .' '. $headerBgPosition . ' top'; 
	}
	?>
	#Top { background: <?php echo $headerBg ?>; }
	<?php 

	// Fonts
	//................................................................

	$font_Heading  = get_options_data('options-page', 'font-heading-standard');
	$font_Body     = get_options_data('options-page', 'font-body-standard');
	$gFont_Heading = get_options_data('options-page', 'font-heading-google');
	$gFont_Body    = get_options_data('options-page', 'font-body-google');
	$color_Heading = get_options_data('options-page', 'font-heading-color');
	$color_Body    = get_options_data('options-page', 'font-body-color');
	// Standard Font Index
	$standard_font = array(
		"arial" => "Arial,Helvetica,Garuda,sans-serif",
		"arial-black" => "'Arial Black',Gadget,sans-serif",
		"courier-new" => "'Courier New',Courier,monospace",
		"georgia" => "Georgia,'Times New Roman',Times, serif",
		"lucida-console" => "'Lucida Console',Monaco,monospace",
		"lucida-sans-unicode" => "'Lucida Sans Unicode','Lucida Grande',sans-serif",
		"palatino-linotype" => "'Palatino Linotype','Book Antiqua',Palatino,serif",
		"tahoma" => "Tahoma,Geneva,sans-serif",
		"times-new-roman" => "'Times New Roman',Times,serif",
		"trebuchet-ms" => "'Trebuchet MS',Arial,Helvetica,sans-serif",
		"verdana" => "Verdana,Geneva,sans-serif"
	);

	// Heading font
	//................................................................

	$headingFont = false;
	if (!empty($gFont_Heading)) {
		// Get just the font name
		$headingFont = str_replace( '+', ' ', substr($gFont_Heading, 0, (strpos($gFont_Heading, ':')) ? strpos($gFont_Heading, ':') : strlen($gFont_Heading)) );
	} elseif ($font_Heading != 'default') {
		$headingFont = $standard_font[$font_Heading];
	}
	if ($headingFont) { ?>
		h1, h2, h3, h4, h5, h6, h2.wpb_call_text, .comments-area article header cite, .vc_text_separator div, nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > a > .ubermenu-target-title, nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > span > .ubermenu-target-title, nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul.ubermenu-has-submenu-mega > li.ubermenu-item > a, nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul.ubermenu-has-submenu-mega > li.ubermenu-item:hover > a, nav.ubermenu.ubermenu-main ul li.menu-item-level-0 ul ul.ubermenu-submenu li.ubermenu-item-header > a .ubermenu-target-title, nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul ul.ubermenu-submenu li.ss-nav-menu-header > a:hover .ubermenu-target-title, .headline, .entry-title.headline { font-family: <?php echo $headingFont ?>; }
		<?php
	}
	if (!empty($color_Heading)) { ?>
		h1, h2, h3, h4, h5, h6, h2.wpb_call_text, .comments-area article header cite, .vc_text_separator div, .wpb_accordion .ui-accordion .ui-accordion-header a, .site-header .site-title a, .entry-title, .entry-title a, .wpb_carousel .post-title a, .widget-area .widget li[class*="current"] a, div.wpb_content_element div.ui-tabs .ui-tabs-nav li.ui-tabs-active a, .iconBox.icon i[class^="icon-"], #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > a, #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-item > span.um-anchoremulator, #MainNav .ubermenu-responsive-toggle, .home #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-current-menu-item > a .ubermenu-target-title, .homepage #MainNav nav.ubermenu.ubermenu-main ul.ubermenu-nav > li.ubermenu-current-menu-item > a .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul.ubermenu-submenu-type-mega > li.ubermenu-item > a .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul.ubermenu-submenu-type-mega > li.ubermenu-item:hover > a .ubermenu-target-title, nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul ul.ubermenu-submenu li.ubermenu-item-header > a .ubermenu-target-title, nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul ul.ubermenu-submenu li.ubermenu-item-header > a:hover .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul ul.ubermenu-submenu li.ubermenu-item-header > a .ubermenu-target-title, #MainNav nav.ubermenu.ubermenu-main ul li.ubermenu-item-level-0 ul ul.ubermenu-submenu li.ubermenu-item-header > a:hover .ubermenu-target-title, #MainNav .wpmega-widgetarea h2.widgettitle { color: <?php echo $color_Heading ?>; }
		<?php
	}

	// Body font
	//................................................................

	$bodyFont = false;
	if (!empty($gFont_Body)) {
		// Get just the font name
		$bodyFont = str_replace( '+', ' ', substr($gFont_Body, 0, strpos($gFont_Body, ':')) );
		$bodyFont = str_replace( '+', ' ', substr($gFont_Body, 0, (strpos($gFont_Body, ':')) ? strpos($gFont_Body, ':') : strlen($gFont_Body)) );
	} elseif ($font_Body != 'default') {
		$bodyFont = $standard_font[$font_Body];
	}
	if ($bodyFont || !empty($color_Body)) { ?>
		body { <?php 
			if ($bodyFont)   { echo 'font-family: '.$bodyFont.';' ; } 
			if ($color_Body) { echo 'color: '.$color_Body.';' ; } 
			?> }
		<?php
	}

	// Custom CSS (user generated)
	//................................................................

	echo stripslashes(htmlspecialchars_decode(get_options_data('options-page', 'custom-styles'),ENT_QUOTES));

}
endif; ?>