<?php

#-----------------------------------------------------------------
# Enable shortdoces in sidebar default Text widget
#-----------------------------------------------------------------
add_filter('widget_text', 'do_shortcode');

#-----------------------------------------------------------------
# Post Format Media
#-----------------------------------------------------------------

// Output Gallery (slide show) for Post Format
//...............................................

if ( !function_exists( 'theme_gallery_slideshow' ) ) :
    function theme_gallery_slideshow($post_id, $thumbnail = 'post-thumbnail') {

    	$post_id = ($post_id) ? $post_id : $post->ID;

    	// Get the media ID's
		$ids = esc_attr(get_post_meta($post_id, 'postformat_gallery_ids', true));

		// Query the media data
		$attachments = get_posts( array(
			'post__in' => explode(",", $ids),
			'orderby' => 'post__in',
			'post_type' => 'attachment',
			'post_mime_type' => 'image',
			'post_status' => 'any',
			'numberposts' => -1
		));
		
		// Link image to post
		$before = '<div class="plain-image">'; $after = '</div>';
		if ( ! is_single() )  {
			$before = '<a href="'. get_permalink() .'" title="'. sprintf( __( 'Permalink to %s', 'framework' ), the_title_attribute( 'echo=0' ) ) .'" rel="bookmark" class="plain-image '. get_post_format() .'">'; 
			$after = '<div class="inner-overlay"></div></a>';
		}

		// Create the media display
		if ($attachments) {
			echo '<div class="flexslider"><ul class="slides">';
			foreach ($attachments as $attachment) {

				echo '<li>'. $before . wp_get_attachment_image($attachment->ID, $thumbnail) . $after .'</li>';
			}
			echo '</ul></div>';
		}			
	}
endif;

// Output Audio Player for Post Format
//...............................................

if ( !function_exists( 'theme_audio_player' ) ) :
    function theme_audio_player($post_id, $width = 1200) {

    	// Get the player media
		$mp3    = get_post_meta($post_id, 'postformat_audio_mp3', TRUE);
		$ogg    = get_post_meta($post_id, 'postformat_audio_ogg', TRUE);
		$embed  = get_post_meta($post_id, 'postformat_audio_embedded', TRUE);
		$height = get_post_meta($post_id, 'postformat_poster_height', TRUE);

		if ( isset($embed) && $embed != '' ) {
			// Embed Audio
			if( !empty($embed) ) {
				// run oEmbed for known sources to generate embed code from audio links
				echo '<div class="audio-container">'. $GLOBALS['wp_embed']->autoembed( stripslashes(htmlspecialchars_decode($embed)) ) .'</div>';

				return; // and.... Done!
			}

		} else {
		    // Other audio formats ?>

			<script type="text/javascript">
		
				jQuery(document).ready(function(){

					if(jQuery().jPlayer) {
						jQuery("#jquery_jplayer_<?php echo $post_id; ?>").jPlayer({
							ready: function (event) {

								// set media
								jQuery(this).jPlayer("setMedia", {
								    <?php 
								    /*
								    if($poster != '') :
								    	echo 'poster: "'. $poster .'",';
								    endif;
								    */
								    if($mp3 != '') :
										echo 'mp3: "'. $mp3 .'",';
									endif;
									if($ogg != '') :
										echo 'oga: "'. $ogg .'",';
									endif; ?>
									end: ""
								});
							},
							<?php if( !empty($poster) ) { ?>
							size: {
	        				    width: "<?php echo $width; ?>px",
	        				    height: "<?php echo $height . 'px'; ?>"
	        				},
	        				<?php } ?>
							swfPath: "<?php echo get_stylesheet_directory_uri(); ?>/assets/js",
							cssSelectorAncestor: "#jp_interface_<?php echo $post_id; ?>",
							supplied: "<?php if($ogg != '') : ?>oga,<?php endif; ?><?php if($mp3 != '') : ?>mp3, <?php endif; ?> all"
						});
					
					}
				});
			</script>

			<div id="jquery_jplayer_<?php echo $post_id; ?>" class="jp-jplayer jp-jplayer-audio"></div>

			<div class="jp-audio-container">
				<div class="jp-audio">
					<div class="jp-type-single">
						<div id="jp_interface_<?php echo $post_id; ?>" class="jp-interface">
							<ul class="jp-controls">
								<li><div class="seperator-first"></div></li>
								<li><div class="seperator-second"></div></li>
								<li><a href="#" class="jp-play" tabindex="1"><i class="fa fa-play"></i><span>play</span></a></li>
								<li><a href="#" class="jp-pause" tabindex="1"><i class="fa fa-pause"></i><span>pause</span></a></li>
								<li><a href="#" class="jp-mute" tabindex="1"><i class="fa fa-volume-up"></i><span>mute</span></a></li>
								<li><a href="#" class="jp-unmute" tabindex="1"><i class="fa fa-volume-off"></i><span>unmute</span></a></li>
							</ul>
							<div class="jp-progress-container">
								<div class="jp-progress">
									<div class="jp-seek-bar">
										<div class="jp-play-bar"></div>
									</div>
								</div>
							</div>
							<div class="jp-volume-bar-container">
								<div class="jp-volume-bar">
									<div class="jp-volume-bar-value"></div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<?php 
		} // End if embedded/else
    }
endif;

// Video Player / Embeds (self-hosted, jPlayer)
//...............................................

if ( !function_exists( 'theme_video_player' ) ) :
    function theme_video_player($post_id, $width = 1200) {
	
    	// Check for embedded video
    	$embed = get_post_meta($post_id, 'postformat_video_embed', true); 
		if( !empty($embed) ) {
			// run oEmbed for known sources to generate embed code from video links
			echo '<div class="video-container">'. $GLOBALS['wp_embed']->autoembed( stripslashes(htmlspecialchars_decode($embed)) ) .'</div>';

			return; // and.... Done!
		}


		// Get the player media options
    	$height = get_post_meta($post_id, 'postformat_video_height', true);
    	$m4v = get_post_meta($post_id, 'postformat_video_m4v', true);
    	$ogv = get_post_meta($post_id, 'postformat_video_ogv', true);
    	$webm = get_post_meta($post_id, 'postformat_video_webm', true);
    	$poster = get_post_meta($post_id, 'postformat_video_poster', true);
	
		?>
	    <script type="text/javascript">
	    	jQuery(document).ready(function(){
			
	    		if(jQuery().jPlayer) {
	    			jQuery("#jquery_jplayer_<?php echo $post_id; ?>").jPlayer({
	    				ready: function (event) {
							// mobile display helper
							// if(event.jPlayer.status.noVolume) {	$('#jp_interface_<?php echo $post_id; ?>').addClass('no-volume'); }
							// set media
	    					jQuery(this).jPlayer("setMedia", {
	    						<?php if($m4v != '') : ?>
	    						m4v: "<?php echo $m4v; ?>",
	    						<?php endif; ?>
	    						<?php if($ogv != '') : ?>
	    						ogv: "<?php echo $ogv; ?>",
	    						<?php endif; ?>
	    						<?php if($webm != '') : ?>
	    						webmv: "<?php echo $webm; ?>",
	    						<?php endif; ?>
	    						<?php if ($poster != '') : ?>
	    						poster: "<?php echo $poster; ?>"
	    						<?php endif; ?>
	    					});
	    				},
	    				size: {
	    				    width: "<?php echo $width ?>px",
	    				    // height: "<?php echo $height . 'px'; ?>"
	    				},
	    				swfPath: "<?php echo get_stylesheet_directory_uri(); ?>/assets/js",
	    				cssSelectorAncestor: "#jp_interface_<?php echo $post_id; ?>",
	    				supplied: "<?php if($m4v != '') : ?>m4v, <?php endif; ?><?php if($ogv != '') : ?>ogv, <?php endif; ?> all"
	    			});
	    		}
	    	});
	    </script>

	    <div id="jquery_jplayer_<?php echo $post_id; ?>" class="jp-jplayer jp-jplayer-video"></div>

	    <div class="jp-video-container">
	        <div class="jp-video">
	            <div class="jp-type-single">
	                <div id="jp_interface_<?php echo $post_id; ?>" class="jp-interface">
	                    <ul class="jp-controls">
	                    	<li><div class="seperator-first"></div></li>
	                        <li><div class="seperator-second"></div></li>
	                        <li><a href="#" class="jp-play" tabindex="1"><i class="fa fa-play"></i><span>play</span></a></li>
	                        <li><a href="#" class="jp-pause" tabindex="1"><i class="fa fa-pause"></i><span>pause</span></a></li>
	                        <li><a href="#" class="jp-mute" tabindex="1"><i class="fa fa-volume-up"></i><span>mute</span></a></li>
	                        <li><a href="#" class="jp-unmute" tabindex="1"><i class="fa fa-volume-off"></i><span>unmute</span></a></li>
	                    </ul>
	                    <div class="jp-progress-container">
	                        <div class="jp-progress">
	                            <div class="jp-seek-bar">
	                                <div class="jp-play-bar"></div>
	                            </div>
	                        </div>
	                    </div>
	                    <div class="jp-volume-bar-container">
	                        <div class="jp-volume-bar">
	                            <div class="jp-volume-bar-value"></div>
	                        </div>
	                    </div>
	                </div>
	            </div>
	        </div>
	    </div>
	    <?php 

	}
endif;


#-----------------------------------------------------------------
# Excerpt Functions
#-----------------------------------------------------------------

// Replace "[...]" in excerpt with "..."
//................................................................
function new_excerpt_more($excerpt) {
	return str_replace('[...]', '...', $excerpt);
}
add_filter('wp_trim_excerpt', 'new_excerpt_more');


// Modify the WordPress excerpt length
//................................................................
/**
 * We set this pretty high because our "customExcerpt" function 
 * uses the WordPress excerpt for its source since it is already 
 * stripped of HTML, images, shortcodes, etc.  
 * 
 */
function new_excerpt_length($length) {
	return 250;
}
add_filter('excerpt_length', 'new_excerpt_length');


// Custom Length Excerpts
//................................................................
/**
 * Usage:
 *
 * echo customExcerpt(get_the_content(), 30);
 * echo customExcerpt(get_the_content(), 50);
 * echo customExcerpt($your_content, 30);
 * 
 */
function customExcerpt($excerpt = '', $excerpt_length = 50, $tags = '', $trailing = '...') {
	global $post;
	
	if (has_excerpt()) {
		// see if there is a user created excerpt, if so we use that without any trimming
		return  get_the_excerpt();
	} else {
		// otherwise make a custom excerpt
		$string_check = explode(' ', $excerpt);
		if (count($string_check, COUNT_RECURSIVE) > $excerpt_length) {
			$excerpt = strip_shortcodes( $excerpt );
			$new_excerpt_words = explode(' ', $excerpt, $excerpt_length+1); 
			array_pop($new_excerpt_words);
			$excerpt_text = implode(' ', $new_excerpt_words); 
			$temp_content = strip_tags($excerpt_text, $tags);
			$short_content = preg_replace('`\[[^\]]*\]`','',$temp_content);
			$short_content .= $trailing;
			
			return $short_content;
		} else {
			// no trimming needed, excerpt is too short.
			return $excerpt;
		}
	}
} 


#-----------------------------------------------------------------
# Other Fixes
#-----------------------------------------------------------------

// Fix wmode in WP oEmbeds
//...............................................
/**
 * Prevents iframes (like YouTube) from floating over menus z-indexed CSS
 */
function add_video_wmode_transparent($html, $url, $attr) {
   if (strpos($html, "<embed src=" ) !== false) {
        $html = str_replace('</param><embed', '</param><param name="wmode" value="transparent"></param><embed wmode="transparent" ', $html);
        return $html;
   } else {
        return $html;
   }
}
add_filter('embed_oembed_html', 'add_video_wmode_transparent', 10, 3);


// Fix for Jetpack error
//................................................................
/**
 * overrides problem with opengraph tags resulting in error message:
 * Warning: preg_match() expects parameter 2 to be string, object given in /home/nopants/public_html/vellum-demo/wp-includes/post-template.php on line 199
 *
 * The problem is specific to the way the opengraph functions try to get excerpts when applying certain filters, which calls the_content() and returns an
 * object instead of a string, resulting in the error.
 */
add_filter('jetpack_enable_open_graph', 'no_jetpack_opengraph_please', 10, 3);
function no_jetpack_opengraph_please(){
	return false;
}


#-----------------------------------------------------------------
# Color Converstions
#-----------------------------------------------------------------

// HEX->RGB
//................................................................
if ( ! function_exists( 'HexToRGB' ) ) :
	function HexToRGB($hex) {
		$hex = preg_replace('/#/', '', $hex);
		$color = array();
		
		if(strlen($hex) == 3) {
			$color['r'] = hexdec(substr($hex, 0, 1) . $r);
			$color['g'] = hexdec(substr($hex, 1, 1) . $g);
			$color['b'] = hexdec(substr($hex, 2, 1) . $b);
		}
		else if(strlen($hex) == 6) {
			$color['r'] = hexdec(substr($hex, 0, 2));
			$color['g'] = hexdec(substr($hex, 2, 2));
			$color['b'] = hexdec(substr($hex, 4, 2));
		}
		
		return $color;
	}
endif;

if ( ! function_exists( 'get_as_rgba' ) ) :
	function get_as_rgba($hex = '#000000', $opacity = 1) {
		$rgb = HexToRGB($hex);
		$rgba = 'rgba('.$rgb['r'].','.$rgb['g'].','.$rgb['b'].','.$opacity.')';
		
		return $rgba;
	}
endif;

if ( ! function_exists( 'as_rgba' ) ) :
	function as_rgba($hex = '#000000', $opacity = 1) {
		$rgba = get_as_rgba($hex, $opacity);
		echo $rgba;
	}
endif;

	add_filter( 'field-yldKt3FytX5s_data_options', 'default_content_sources' );
	add_filter( 'field-bcbtsvWDSQ3Y_data_options', 'default_content_sources' );
	add_filter( 'field-hK4h0vk3us82_data_options', 'default_content_sources' );
	
	// Default content sources for footers
	function default_content_sources($vars) {

		// Static Blocks
		$args = array(
			'posts_per_page' => -1,
			'post_type' => 'static_block'
		);
		
		$posts = get_posts($args);
		if(!empty($posts)) :
			$vars['Static Block'] = 'OPTION_GROUP_START';	
			foreach ($posts as $key => $value) { 
				$vars[$value->ID] = $value->post_title;
			}
			$vars[] = 'OPTION_GROUP_END';
		endif;
		// Sidebars
		$sidebars = $GLOBALS['wp_registered_sidebars'];
		if(!empty($sidebars)) :		
			$vars['Sidebar'] = 'OPTION_GROUP_START';
			foreach ( $sidebars as $key => $value ) { 
				$vars[$value['id']] = $value['name'];												
			}		
			$vars[] = 'OPTION_GROUP_END';
		endif;
		// Slide shows
		if (class_exists('RevSlider')) : 
			$ss = new RevSlider();
			$arrSliders = $ss->getArrSliders();
			if(!empty($arrSliders)) :
				$vars['Slide Show'] = 'OPTION_GROUP_START';
				foreach($arrSliders as $ss):
					
					// Slide data
					$id    = $ss->getID();
					$title = $ss->getTitle();
					$alias = $ss->getAlias();

					// Select options
					$vars['RevSlider:'.$alias] = $title;
				endforeach;				
				$vars[] = 'OPTION_GROUP_END';
			endif;
		endif; // class_exists('RevSlider')

		return $vars;
	}


#-----------------------------------------------------------------
# Filters for plugin: Beaver Builder
#-----------------------------------------------------------------
// BB Upgrade
//................................................................
if ( ! function_exists( 'parallelus_fl_builder_upgrade_url' ) ) :
	function parallelus_fl_builder_upgrade_url( $url ) {

		return 'http://para.llel.us/+/beaverbuilder';
	}
	add_filter( 'fl_builder_upgrade_url', 'parallelus_fl_builder_upgrade_url', 9999 );
endif;


#-----------------------------------------------------------------
# Filters for plugin: Ninja Forms
#-----------------------------------------------------------------
// NF Upgrade
//................................................................
if ( ! function_exists( 'parallelus_ninja_forms_affiliate_id' ) ) :
	function parallelus_ninja_forms_affiliate_id( $id ) {

		return '1311242';
	}
	add_filter( 'ninja_forms_affiliate_id', 'parallelus_ninja_forms_affiliate_id', 9999 );
endif;
