<?php

#-----------------------------------------------------------------
# Shortcodes using [query] calss
#-----------------------------------------------------------------


// [blog] shortcode
//................................................................
if ( ! function_exists( 'blog_query' ) ) :
	function blog_query($args = null, $content = null) {

		// default template
		if ( !isset($args['template']) || empty($args['template']) ) {
			$args['template'] = 'blog';
		}


		return custom_wp_query($args, $content);
	}
	
	add_shortcode('blog', 'blog_query');
endif;


// [portfolio] shortcode
//................................................................
if ( ! function_exists( 'portfolio_query' ) ) :
	function portfolio_query($args = null, $content = null) {

		// default template
		if ( !isset($args['template']) || empty($args['template']) ) {
			$args['template'] = 'portfolio-filtered';
		}

		// post type
		if ( !isset($args['post_type']) || empty($args['post_type']) ) {
			$args['post_type'] = 'portfolio';
		}

		// orderby
		if ( !isset($args['orderby']) || empty($args['orderby']) ) {
			$args['orderby'] = 'menu_order'; // default by sort order
		}
		if ( !isset($args['order']) || empty($args['order']) ) {
			$args['order'] = 'ASC'; // default order
		}
		
		// categories 
		if ( isset($args['category']) ) {
			$args['taxonomy_slug'] = 'portfolio-category';
			$args['taxonomy_terms'] = $args['category'];
			unset($args['category']);
		}

		return custom_wp_query($args, $content);
	}
	
	add_shortcode('portfolio', 'portfolio_query');
endif;

?>