<!DOCTYPE html>
<!--[if lt IE 7]>      <html class="no-js lt-ie9 lt-ie8 lt-ie7"> <![endif]-->
<!--[if IE 7]>         <html class="no-js lt-ie9 lt-ie8"> <![endif]-->
<!--[if IE 8]>         <html class="no-js lt-ie9"> <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" <?php language_attributes(); ?>> <!--<![endif]-->
<head>
	<meta charset="<?php bloginfo( 'charset' ); ?>" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
	<meta name="viewport" content="width=device-width">
	<title><?php wp_title( '|', true, 'right' ); ?></title>
	<link rel="profile" href="http://gmpg.org/xfn/11" />
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />
	<link rel="shortcut icon" href="<?php options_data('options-page', 'favorites-icon'); ?>">
	<link rel="apple-touch-icon-precomposed" href="<?php options_data('options-page', 'mobile-bookmark'); ?>">
	<?php wp_head(); ?>
</head>

<body <?php body_class(); ?>>

<?php

// Header Data
//................................................................
$header = get_layout_header();
$headerSuffix = (isset($header['alias'])) ? $header['alias'] : '';

// Full screen background images
//................................................................

$bodyPosition = get_options_data('options-page', 'background-position');
$bodyImage    = get_options_data('options-page', 'background-image');
if ( $bodyImage && $bodyPosition == 'full-screen' ) {
	echo '<img src="' . $bodyImage . '" alt="' . esc_attr( generate_title() ) . '" id="full-background" />';
}
?>	
<div id="page" class="hfeed site">

	<div id="Top">
		<header id="masthead" class="site-header" role="banner">
			<div class="masthead-container">
				<div class="inner-content">
					<div class="hgroup">
						<h1 class="site-title">
							<?php

							// Logo
							//................................................................

							$home_url = (get_options_data('options-page', 'logo-url')) ? get_options_data('options-page', 'logo-url') : home_url( '/' );
							?>
							<a href="<?php echo esc_url( $home_url ); ?>" title="<?php echo esc_attr( get_bloginfo( 'name', 'display' ) ); ?>" class="logo" rel="home">
								<?php
								
								// The logo image or text
								$logoImage = get_options_data('options-page', 'logo-image');
								// if ( !empty($header['header_alternate_logo']) ) { 
								// 	$logoImage = $header['header_alternate_logo'];
								// }
								if ( get_options_data('layout_header_' . $headerSuffix, 'field-sHS1oOmcdqPl') != "" ) {
									$logoImage = get_options_data('layout_header_' . $headerSuffix, 'field-sHS1oOmcdqPl');
								}
								$logo = ($logoImage) ? '<img src="'.$logoImage.'" alt="'.get_options_data('options-page', 'logo-title').'">' : bloginfo('name');
								echo $logo;
								
								?>
							</a>
						</h1>
					</div><!-- .hgroup -->

					<div id="MainNav" class="navRight">
						<?php 

						// Navigation - Main Menu
						//................................................................

						if ( function_exists( 'uberMenu_direct' ) ) {
							// Call Ubermenu 
							uberMenu_direct( 'primary' );
						} else {
							// Call WP Nav Menu ?>
							<nav id="site-navigation" class="main-navigation" role="navigation">
								<?php wp_nav_menu( array( 'theme_location' => 'primary', 'menu_class' => 'nav-menu' ) ); ?>
							</nav><!-- #site-navigation -->
							<?php
						} ?>
					</div><!-- / #MainNav -->

					<div class="clear"></div>
				</div>
			</div><!-- .masthead-container -->
		</header><!-- #masthead -->
		<?php 

		// Header Content
		//................................................................

		$sectionClass = '';
		$type = 'default';
		$extendBg = (get_options_data('options-page', 'extend-header-bg')) ? true : false;
		if (empty($header) || !isset($header)) {
			$type = 'default';
		} else {
			if ( is_numeric(get_options_data('layout_header_' . $headerSuffix, 'field-yldKt3FytX5s')) ) {
				// We have a static block for content
				$type = 'static_block';
			} elseif ( get_options_data('layout_header_' . $headerSuffix, 'field-yldKt3FytX5s') != 'default' ) {
				// The content is a sidebar or slide show
				$content = explode(':', get_options_data('layout_header_' . $headerSuffix, 'field-yldKt3FytX5s'));
				if (is_array($content) && $content[0] == 'RevSlider') {
					$type = 'slideshow';
					// Get slide show information
					$sliderAlias   = apply_filters( 'header-slide-show', $content[1] );
					$sectionClass  = 'rev_slider-'. $sliderAlias;
					$sectionClass .= ($extendBg) ? ' extendBg' : '';
				} else {
					$type = 'sidebar';
				}
			} else {
				$type = 'default';
			}
		} ?>	
		<section id="TopContent" class="<?php echo $sectionClass ?>">
			<?php

			if ($type == 'slideshow' && function_exists('putRevSlider')) :
				// Slide show
				putRevSlider( $sliderAlias ); 

				// Helper for extended background scaling
				if ($extendBg) : 
					?>
					<script type="text/javascript">
						jQuery(document).ready(function($) {
							var extendedBg = function() {
								if ($('#TopContent').width() < 768) {
									extend_ratio = 132 / <?php echo $GLOBALS['max_content_width'] ?>;
									$('#TopContent .rev_slider_wrapper').css('margin-top', '-' + $('#TopContent').width() * extend_ratio + 'px');
								} else {
									$('#TopContent .rev_slider_wrapper').css('margin-top', 0);
								}
							}
							$(window).on("resize", function( event ) { extendedBg(); });
						});
					</script>
					<?php
				endif; // end extended background helper

			else :
				// Default Header (title and breadcrumbs) ?>
				<div class="inner-content">
					<?php
					if ($type != 'default') :
						echo get_layout_content_block($type, get_options_data('layout_header_' . $headerSuffix, 'field-yldKt3FytX5s'));
					else : ?>
						<div class="row-fluid header-default">
							<div class="span8 default-title">
								<h1 class="page-title headline"><?php echo generate_title(); ?></h1>
							</div>
							<div class="span4 default-breadcrumbs">
								<?php if(function_exists('breadcrumbs_display')) {
									breadcrumbs_display();
								}?>
							</div>
						</div>
						<?php
					endif; // $type != 'default' ?>
				</div>
				<?php
			endif; // $type == 'slideshow' ?>
			<div class="top-inner-shadow"></div>
		</section><!-- #TopContent -->
	</div><!-- #Top -->

	<div id="Middle">
		<div class="inner-content main-content">

			<?php do_action('output_layout','start'); ?>