<?php get_header(); ?>

	<div id="primary" class="site-content">
		<div id="content" role="main">

			<?php while ( have_posts() ) : the_post(); ?>

			<header class="post-header">
				<?php 

				// Post formats that use the featured image (standard, image, audio)
				// --------------------------------------------------------------------
				$no_thumbnail = array('gallery', 'video');
				$media = get_the_post_thumbnail($post->ID, 'full-thumb');
				if ( $media && !in_array(get_post_format(), $no_thumbnail) ) : 
					?>
					<div class="featured-image">
						<div class="shadow-curl styled-image <?php echo get_post_format() ?>">
							<?php echo $media ?>
							<div class="inner-overlay"></div>
						</div>
					</div>
					<?php 
				endif;

				// Media selected by post format
				switch( get_post_format() ) {

					case "audio" :
						// Audio Player
						theme_audio_player($post->ID);
						break;
					case "gallery" :
						?>
						<div class="featured-image">
							<div class="shadow-curl styled-image <?php echo get_post_format() ?>"><?php theme_gallery_slideshow($post->ID, false, 'full-thumb'); ?></div>
						</div>
						<?php
						break;
					case "video" :
						// Video Player or Embed
						theme_video_player($post->ID);
						break;
				} ?>

			</header>

			<h1 class="page-title"><?php the_title(); ?></h1>

			<div class="row-fluid">
				<div class="span8">

					<div class="entry-content">
						<?php the_content(); ?>
					</div><!-- .entry-content -->

				</div>
				<div class="span4">
					<div class="entry-meta portfolio-details">
						<?php 
							// Portfolio meta details
							if( $item_client = get_post_meta($post->ID, 'theme_portfolio_client', true) ) {
								echo '<h5>' . __('Client', 'framework') .'</h5><p>'. $item_client .'</p>';
							}
							if( $item_date = get_post_meta($post->ID, 'theme_portfolio_date', true) ) {
								echo '<h5>' . __('Date', 'framework') .'</h5><p>'. $item_date .'</p>';
							}
							if( $item_details = get_post_meta($post->ID, 'theme_portfolio_details', true) ) {
								echo '<div>'. stripslashes(htmlspecialchars_decode($item_details)) .'</div>';
							}
							if( $item_url = get_post_meta($post->ID, 'theme_portfolio_url', true) ) {
								echo '<h5 class="project-link"><a href="'. $item_url .'">'. __('View Project', 'framework') .' <i class="fa fa-arrow-right"></i></a></h5><br>';
							}
						?>
					</div>

				</div>

				<footer class="entry-footer entry-meta">
					<span class="entry-portfolio-category"><?php the_terms($post->ID, 'portfolio-category', '', ', ', ''); ?></span>
				</footer><!-- .entry-meta -->

				<nav class="nav-single">
					<h3 class="assistive-text"><?php _e( 'Portfolio navigation', 'framework' ); ?></h3>
					<span class="nav-previous"><?php previous_post_link( '%link', '<span class="meta-nav">' . _x( '&larr;', 'Previous item link', 'framework' ) . '</span> %title' ); ?></span>
					<span class="nav-next"><?php next_post_link( '%link', '%title <span class="meta-nav">' . _x( '&rarr;', 'Next item link', 'framework' ) . '</span>' ); ?></span>
				</nav><!-- .nav-single -->

			</div>

			<?php endwhile; // end of the loop. ?>
			<?php edit_post_link( __( 'Edit', 'framework' ), '<span class="edit-link">', '</span>' ); ?>

		</div><!-- #content -->
	</div><!-- #primary -->

<?php get_footer(); ?>