<?php global $column_left, $column_right, $max_columns;
/**
 * The template for displaying audio format posts
 */

// Media
$headerClass = ($column_left) ? 'span'.$column_left : ''; ?>
<header class="post-header <?php echo $headerClass ?>">
	<?php 

	// Featured Image: Audio Player "Poster"
	if ( has_post_thumbnail() ) :

		// Image
		$size  = get_post_image_size();
		$media = (is_single() && !get_options_data('blog-options', 'single-post-image', false)) ? false : get_the_post_thumbnail($post->ID, $size);
		$media .= '<div class="inner-overlay"></div>'; 

		// Show the image (linked if blog list) ?>
		<div class="featured-image">
		<?php if ( is_single() ) : ?>
			<div class="shadow-curl styled-image <?php echo get_post_format() ?>"><?php echo $media; ?></div>
		<?php else : ?>
			<a href="<?php the_permalink(); ?>" class="shadow-curl styled-image <?php echo get_post_format() ?>" title="<?php echo esc_attr( sprintf( __( 'Permalink to %s', 'framework' ), the_title_attribute( 'echo=0' ) ) ); ?>" rel="bookmark"><?php echo $media ?></a>
		<?php endif; // is_single() ?>
		</div>
		<?php 
	endif;

	// Audio Player
	theme_audio_player($post->ID); 

	?>
</header>

<?php 
// Set a column width if using columns and we have media (an image)
if ($column_right && $headerClass) : ?>
<div class="span<?php echo  $column_right ?>">
<?php endif; 

	// Post title
	theme_post_title();

	// Post Content
	theme_post_content();


if ($column_right && $headerClass) : ?>
</div><!-- .span# -->
<?php endif; ?>