<?php global $column_left, $column_right, $headerClass;
/**
 * 
 * The default template for displaying content. Used for post formats: standard and image, Views: blog, index, archive, search and single posts.
 *
 */

// Image size
$size  = get_post_image_size();
$media = (is_single() && !get_options_data('blog-options', 'single-post-image', false)) ? false : get_the_post_thumbnail($post->ID, $size);

// Header - standard post
if ( (!get_post_format() || get_post_format() == 'image') && $media ) : 

	$media .= '<div class="inner-overlay"></div>';
	
	// Formatting for media alignment	
	$headerClass = ($column_left) ? 'span'.$column_left : ''; ?>

	<header class="post-header <?php echo $headerClass ?>">
		<div class="featured-image">
		<?php if ( is_single() ) : ?>
			<div class="shadow-curl styled-image <?php echo get_post_format() ?>"><?php echo $media; ?></div>
		<?php else : ?>
			<a href="<?php the_permalink(); ?>" class="shadow-curl styled-image <?php echo get_post_format() ?>" title="<?php echo esc_attr( sprintf( __( 'Permalink to %s', 'framework' ), the_title_attribute( 'echo=0' ) ) ); ?>" rel="bookmark"><?php echo $media ?></a>
		<?php endif; // is_single() ?>
		</div>
	</header>

	<?php 
endif; 

// Content
if ($column_right && $headerClass) : 
	// If using columns ?>
	<div class="span<?php echo  $column_right ?>">
	<?php 
endif;

	// Post title
	theme_post_title();

	// Post Content
	theme_post_content();

if ($column_right && $headerClass) : ?>
	</div><!-- .span# -->
	<?php 
endif; ?>